<template>
  <header class="grid-template right-border header">
    <button
      class="header-btn"
      @mouseenter="showSideBar"
      @mouseleave="hideSideBar"
      @click="toggleSideMenu"
      :class="{ 'active-header-button': isSideBarVisible }"
    >
      <p v-if="!isCloseIconVisible" class="header-btn-text">menu</p>
      <CloseIcon v-if="isCloseIconVisible" />
    </button>
    <img alt="BlooBloom logo" class="logo" src="@/assets/logo.png" />
  </header>
  <MenuBarVue
    :is-side-bar-visible="isSideBarVisible"
    @mouseenter="showSideBar"
    @mouseleave="hideSideBar"
    :show-sub-menu="showSubMenu"
  />
  <SubMenu
    @mouseenter="mouseShowSubmenu"
    @mouseleave="mouseLeaveSubmenu"
    :is-sub-menu-visible="isSubMenuVisible"
    :change-glasses-type="changeTypeAndHide"
    :active-type-button="activeTypeButton"
    :hide-sub-menu="hideSubMenu"
  />
</template>
<script lang="ts">
import type { GLASSES_TYPES } from '@/types/glasses'
import MenuBarVue from './Menu/MenuBar.vue'
import SubMenu from './Menu/SubMenu.vue'
import CloseIcon from '@/components/icons/CloseIcon.vue'
export default {
  components: {
    MenuBarVue,
    SubMenu,
    CloseIcon
  },
  props: {
    changeGlassesType: {
      type: Function,
      required: true
    }
  },
  data() {
    return {
      isSideBarVisible: false,
      isSubMenuVisible: false,
      activeTypeButton: '',
      sizeIsSmall: false
    }
  },
  computed: {
    isCloseIconVisible() {
      return this.sizeIsSmall && (this.isSideBarVisible || this.isSubMenuVisible)
    }
  },
  methods: {
    showSideBar() {
      this.isSideBarVisible = true
    },
    hideSideBar() {
      this.isSideBarVisible = false
      this.isSubMenuVisible = false
    },
    showSubMenu(type: string) {
      this.isSubMenuVisible = true
      this.isSideBarVisible = true
      this.activeTypeButton = type
    },
    hideSubMenu() {
      this.isSubMenuVisible = false
      this.activeTypeButton = ''
    },
    changeTypeAndHide(glassesType: GLASSES_TYPES) {
      this.changeGlassesType(glassesType)
      this.hideSubMenu()
      this.hideSideBar()
    },
    mouseShowSubmenu() {
      this.isSubMenuVisible = true
      this.isSideBarVisible = true
    },
    mouseLeaveSubmenu() {
      this.hideSideBar()
      this.hideSubMenu()
    },
    toggleSideMenu() {
      if (this.sizeIsSmall && (this.isSideBarVisible || this.isSubMenuVisible)) {
        this.hideSideBar()
      } else {
        this.showSideBar()
      }
    },
    checkScreenWidth() {
      this.sizeIsSmall = window.innerWidth <= 500
    }
  },
  mounted() {
    this.checkScreenWidth()
    window.addEventListener('resize', this.checkScreenWidth)
  },
  beforeUnmount() {
    window.removeEventListener('resize', this.checkScreenWidth)
  }
}
</script>
